<script setup lang="ts">
import type { PropType } from 'vue';
import {
  GitlabRocket,
  UserChat,
  GitlabEnvironmentToolkit,
  RemoteIdeaCollaboration,
  RemoteHandbook,
  GitlabPipeline,
  CollaborationAlt,
  Scale,
  RocketAlt,
  WebcastAlt,
  CogCodeAlt,
  CreateAlt,
  OpenSourceAlt,
  RemoteUserLaptop,
  CommunityAlt2,
  FirstLookInfluence,
  ChevronLgRight,
} from 'slippers-ui/icons';
import type { BaseCard } from '@/types/base';

const icons = {
  GitlabRocket,
  UserChat,
  GitlabEnvironmentToolkit,
  RemoteIdeaCollaboration,
  RemoteHandbook,
  GitlabPipeline,
  CollaborationAlt,
  Scale,
  RocketAlt,
  WebcastAlt,
  CogCodeAlt,
  CreateAlt,
  OpenSourceAlt,
  RemoteUserLaptop,
  CommunityAlt2,
  FirstLookInfluence,
};
const { t } = useI18n();

const props = defineProps({
  header: {
    type: String,
    required: true,
  },
  cards: {
    type: Array as PropType<BaseCard[]>,
    required: true,
  },
});

const headerId = toKebabCase(props.header);
</script>

<template>
  <section :id="headerId" class="card-block light-background">
    <SlpContainer>
      <SlpRow class="block-container">
        <SlpColumn :cols="12" class="block__header">
          <SlpTypography tag="h2" variant="heading3" class="title">
            {{ header }}
          </SlpTypography>
        </SlpColumn>
      </SlpRow>
      <SlpRow>
        <SlpColumn>
          <SlpRow :style="{ justifyContent: 'flex-start' }">
            <SlpColumn
              v-for="(card, index) in cards"
              :key="card.header"
              :cols="cards.length % 2 !== 0 && index === 0 ? 12 : 6"
              size="md"
              class="block__col"
            >
              <div class="block">
                <div class="block__wrapper light-background">
                  <div class="block__content-top">
                    <div class="block__category slp-flex">
                      <SlpIcon v-if="card.config?.icon" :icon="icons[card.config?.icon]" size="lg" />
                    </div>
                    <SlpTypography tag="h3" variant="heading4" class="block__title">
                      {{ card.header }}
                    </SlpTypography>
                    <SlpTypography tag="p" variant="body2" class="block__description">
                      {{ card.description }}
                    </SlpTypography>
                    <SlpButton
                      v-if="card.button?.config?.href"
                      variant="tertiary"
                      class="learn-more"
                      :href="card.button.config?.href"
                      :data-ga-name="`${card.header?.toLowerCase()} learn more CTA`"
                      data-ga-location="body"
                    >
                      {{ t('commonCtas.learnMore') }}
                      <SlpIcon :icon="ChevronLgRight" />
                    </SlpButton>
                  </div>
                </div>
              </div>
            </SlpColumn>
          </SlpRow>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.card-block {
  background-color: $color-surface-800;
  padding: $spacing-64 0;
  position: relative;
  &.light-background {
    background: $color-primary-300;
    &:after {
      background: $color-primary-300;
    }
  }
  .learn-more {
    padding-left: 0;
    margin-top: auto;
  }
  @media (max-width: $breakpoint-md) {
    padding: $spacing-48 0;
  }

  h2 {
    font-size: $text-heading-2;
    line-height: $line-height-heading-2;
    font-weight: $font-weight-bold;
  }

  .block {
    display: flex;
    position: relative;
    height: 100%;

    &__wrapper {
      display: flex;
      flex-direction: column;
      transition: all 0.3s ease-in-out;
      justify-content: space-between;
      padding: $spacing-32;
      background: $color-primary-300;
      &.light-background {
        background: $color-surface-800;
      }
      flex: 1;
      border-radius: $spacing-4;
      @media (min-width: $breakpoint-md) {
        margin: $spacing-8 $spacing-16 $spacing-8 0;
      }
      @media (max-width: $breakpoint-md) {
        margin: $spacing-8 0;
      }
    }

    &__header {
      width: 100%;
      display: flex;
      flex-direction: row;
      justify-content: space-between;
      align-items: center;
    }

    &__image {
      max-width: 100%;
    }

    &__link {
      color: $color-text-300;
      padding-left: 0;
    }

    &__title {
      margin-bottom: $spacing-16;
      font-size: $text-heading-4;
      font-weight: $font-weight-bold;
    }

    &__description {
      margin-bottom: $spacing-16;
      &:deep(a:hover) {
        text-decoration: underline;
      }
    }

    &__list {
      margin-bottom: $spacing-16;

      .item {
        margin-bottom: $spacing-16;
        display: flex;
      }

      .bullet {
        margin-right: $spacing-8;
      }
    }

    &__content-top {
      display: flex;
      flex-basis: 100%;
      flex-direction: column;
      p,
      h3,
      li {
        color: $color-text-300;
      }

      :last-child {
        margin-bottom: 0;
      }
    }
    &__col {
      width: 100%;
    }
  }
}
.title {
  margin-top: 32px;
  margin-bottom: 64px;
  &.small-margin {
    margin-bottom: 24px;
  }
}
</style>
